/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.KelompokPegawaiDto;
import com.portofolio.service.KelompokPegawaiService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/kelompokPegawai")
public class KelompokPegawaiController extends LocaleController {
    @Lazy
	@Autowired
    private KelompokPegawaiService kelompokPegawaiService;
    
    
    @ApiOperation("Api Untuk Menyimpan KelompokPegawai")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody KelompokPegawaiDto entity,HttpServletRequest request) {
        Map<String, Object> result = kelompokPegawaiService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update KelompokPegawai")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdKelompokPegawai", required = true) String kdKelompokPegawai,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody KelompokPegawaiDto entity, HttpServletRequest request) {
        Map<String, Object> result = kelompokPegawaiService.update(entity,kdKelompokPegawai,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus KelompokPegawai Berdasarkan KdKelompokPegawai")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdKelompokPegawai", required = true) String kdKelompokPegawai,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = kelompokPegawaiService.deleteById(kdKelompokPegawai, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua KelompokPegawai")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaKelompokPegawai") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaKelompokPegawai", required = false) String namaKelompokPegawai,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = kelompokPegawaiService.grid(page, rows, sort, dir, namaKelompokPegawai,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan KelompokPegawai Berdasarkan kdKelompokPegawai")
    @GetMapping("/findByKdKelompokPegawai")
    public ResponseEntity<Map<String, Object>> findByKdKelompokPegawai(
    		@RequestParam(value = "kdKelompokPegawai", required = true) String kdKelompokPegawai, 
    		HttpServletRequest request) {
        Map<String, Object> result = kelompokPegawaiService.findByKdKelompokPegawai(kdKelompokPegawai);
        return RestUtil.getJsonResponse(result);
    }


}
